#include <iostream>

#include "textfile.h"
#include "timeused.h"
#include "typedefs.h"
#include "choreoExist.h"
#include "toText.h"
#include "parallelShooting.h"


int main()
{
    program_time = 0 ;

   try{

     timeused timeMeter;

    double x[] =
    {
        0.1656647069165702E+01,  0.0000000000000000E+00,  0.0000000000000000E+00, -0.6468913291251014E+00,
        0.5929425965190301E+00,  0.1718650210049859E+00, -0.2174315352692553E+01,  0.5002318593002372E+00,
       -0.5016914678137935E+00,  0.5377928123919029E+00,  0.4139201746432510E+00,  0.1625894655035947E+00,
       -0.1149218345021089E+01, -0.1193136060405927E+00, -0.1714429187085434E+01, -0.3142736094805458E+00,
       -0.1087425278746006E+01, -0.5324061951476085E+00,  0.1277140301624415E+01,  0.7425498887403916E+00,
        0.4887454258961570E+00, -0.5793803220868770E-01,  0.2197684063510321E+01, -0.4442062749385763E+00
    };

     scon.logfile("consoleOutput.txt");
     sout.logfile("report7.txt");
     
#if((MP == 1) || (MP == 2))
     capd::multiPrec::PrecisionType  prec = 100;
     capd::multiPrec::MpfrClass::setDefaultPrecision(prec);
#endif
     //int stop;
     //scon <<"1";
     //std::cin >> stop;
    
     int numberOfBodies = 6;
     int nDiv = 3;
     Interval time = Interval(M_2PI/(double)numberOfBodies/nDiv);
     //scon <<"1";
     //std::cin >> stop;
    
     FloatVector v(numberOfBodies*4);
     for(int i=0; i< numberOfBodies*4; ++i)
       v[i] = x[i];
     
     //scon <<"1";
     //std::cin >> stop;
     
   //FloatVector x0 = loadData("data/6_nosym.nbp", numberOfBodies, nDiv);
     std::cout.precision(16);
     sout << "\n v before splitting \n" << v;
      
     
     v = splitTrajectory(v, numberOfBodies, nDiv, time.leftBound(), 0.0002, 20);
     FloatVector x0 = loadData(v, numberOfBodies, nDiv);
     sout << toText("v after splitting", v, 16);
     double size = 9.e-9;

     int order = 15,
         Xorder = 7;

     double step = 1./512.,
            Xstep = 1./16394.*4;


     ProveChoreographyExistence(x0, size, numberOfBodies, nDiv, time, order, step , Xorder, Xstep);

     sout << "\n\n Time used : " << timeMeter << ".\n";
     return 0;
   }
   catch(std::exception &e)
   {
      sout << e.what();
      return 1;
   }
}
