
#include "typedefs.h"
#include "subVector.h"
#include "nbody.h"

FloatVector splitTrajectory(FloatVector A_x, int A_nBodies, 
                            int A_nDiv, ScalarType A_time, 
                            ScalarType A_step, int A_order)
{
 FloatVector res(A_nDiv * A_nBodies * 4);
 FloatVector x(A_nBodies * 4);
 FloatMap vfield(nBodyEquation2D(A_nBodies));
 FloatTaylor flow(vfield,  A_order, A_step);
 //FloatTaylor flow(taylor);
 ScalarType t =0.0;
 
 copyToSubvector(A_x, res, 0, A_nBodies*4);
 
 for(int i=1; i< A_nDiv; ++i)
 {
   t += A_time;
   while(t > A_step)
   {
     A_x = flow(A_x);
     t -= A_step;
   }
   flow.setStep(t);
   x = flow(A_x);
   flow.setStep(A_step);

   copyToSubvector(x, res, i*A_nBodies*4, (i+1)*A_nBodies*4);
 }

 return res;
}
