

#include "subVector.h"

// Some internal functions to deal with vectors and matrices

void copyToSubvector(IntervalVector &src, IntervalVector &target, int start, int stop)
{
   for(int iTarget=start, iSrc=0; iTarget<stop; ++iTarget, ++iSrc)
      target[iTarget] = src[iSrc];

}
void copyToSubmatrix(IntervalMatrix &src, IntervalMatrix &target, int start, int stop)
{
   for(int iTarget=start, iSrc=0; iTarget<stop; ++iTarget, ++iSrc)
      for(int jTarget=start, jSrc=0; jTarget<stop; ++jTarget, ++jSrc)
         target[iTarget][jTarget] = src[iSrc][jSrc];
}

void copyFromSubvector(IntervalVector &src, IntervalVector &target, int start, int stop)
{
   for(int iSrc=start, iTarget=0; iSrc<stop; ++iTarget, ++iSrc)
      target[iTarget] = src[iSrc];

}

void copyFromSubmatrix(IntervalMatrix &src, IntervalMatrix &target, int startRow, int stopRow, int startCol, int stopCol)
{
   if(startCol == -1)
      startCol = startRow;
   if(stopCol == -1)
      stopCol = stopRow;

   for(int iSrc=startRow, iTarget=0; iSrc<stopRow; ++iTarget, ++iSrc)
      for(int jSrc=startCol, jTarget=0; jSrc<stopCol; ++jTarget, ++jSrc)
         target[iTarget][jTarget] = src[iSrc][jSrc];
}

void intersectionWithSubvector(IntervalVector &src, IntervalVector &target, int start, int stop)
{
   int result = 1;
   for(int iTarget=start, iSrc=0; iTarget<stop; ++iTarget, ++iSrc)
      result = (result && intersection (src[iSrc], target[iTarget], target[iTarget]));
   if(!result)
     throw std::runtime_error(" Null intersection in intersectionWithSubvector ");
}

void intersectionWithSubmatrix(IntervalMatrix &src, IntervalMatrix &target, int start, int stop)
{
   int result =  1;
   for(int iTarget=start, iSrc=0; iTarget<stop; ++iTarget, ++iSrc)
      for(int jTarget=start, jSrc=0; jTarget<stop; ++jTarget, ++jSrc)
         result = (result && intersection(src[iSrc][jSrc], target[iTarget][jTarget], target[iTarget][jTarget]));
   if(!result)
     throw std::runtime_error(" Null intersection in intersectionWithSubvector ");
}

