
#ifndef _TYPEDEFS_H_
#define _TYPEDEFS_H_

#include "capd/interval/DoubleInterval.h"
#include "capd/vectalg/Vector.hpp"
#include "capd/vectalg/Matrix.hpp"

#include "capd/vectalg/Norm.hpp"

#include "capd/map/Function.hpp"
#include "capd/map/Map.hpp"
#include "capd/map/CnMap.h"

#include "capd/dynsys/Taylor.hpp"
#include "capd/dynsys/BasicTaylor.hpp"
//#include "dynsys/cntaylor.h"
//#include "dynsys/basicCnTaylor.h"
//#include "dynsys/taylor.hpp"
#include "capd/dynset/Rect2Set.hpp"
#include "capd/dynset/RectSet.hpp"
#include "capd/dynset/IntervalSet.hpp"
#include "capd/dynset/Intv2Set.hpp"
#include "capd/dynset/C2Rect2.hpp"
#include "capd/dynset/C1Rect2.hpp"
#include "capd/dynset/PpedSet.hpp"
#include "capd/dynset/Pped2Set.hpp"
#include "capd/poincare/TimeMap.h"
#include "capd/poincare/TimeMapTSC.h"


#define DIMENSION 0

typedef capd::vectalg::Vector<double,DIMENSION> FloatVector;
typedef capd::vectalg::Vector<interval,DIMENSION> IntervalVector;
typedef capd::vectalg::Matrix<double,DIMENSION,DIMENSION> FloatMatrix;
typedef capd::vectalg::Matrix<interval,DIMENSION,DIMENSION> IntervalMatrix;

typedef capd::map::Function<FloatVector> Function;
typedef capd::map::CnMap<IntervalMatrix> Map;
typedef capd::map::Map<FloatMatrix> FloatMap;

typedef capd::dynsys::Taylor<Map> Taylor;
typedef capd::dynsys::BasicTaylor<FloatMap> FloatTaylor;
typedef capd::poincare::TimeMap<Taylor> TimeMap;
typedef capd::poincare::TimeMapTSC<Taylor> TimeMapTSC;

typedef MaxLNorm<IntervalVector,IntervalMatrix> LNorm;
typedef capd::dynset::C0Set<IntervalMatrix> C0set;
typedef capd::dynset::C1Rect2<IntervalMatrix> C1rect2;

#endif //_TYPEDEFS_H_
