#include <iostream>
#include <string>
#include "textfile.h"
#include "nbody.h"
#include "typedefs.h"
#include <iomanip>
#include "timeused.h"

#define M_2PI  6.28318530717958647692


IntervalVector loadData(char * name)
{
   double xd[] = {1.076143733510925, 0.0000000000000000,  0.0000000000000000,   0.4682662184090647,
             -0.5380718667554619,  -0.3437068277582447, -1.099603752075198,   -0.2341331092045306};
   FloatVector x0(8, xd);

   IntervalVector x(x0);

   return x;

}


int main()
{
   scon.logfile("raport.txt");



   int numberOfBodies = 3;
   std::string nbody = reducedNBodyEquation2D(numberOfBodies);
   //scon << nbody ;
   Map NBodyEq(nbody);
   interval h = 1./16.;
   TimeMap timeMap(NBodyEq, 15, h);
   
   //TimeMapTSC timeMap2(NBodyEq, 15, 1./1024./1024., 1.e-22, 2);
   TimeMapTSC timeMap2(NBodyEq, 15);
   IntervalVector x = loadData("3body.nbp");

   eLNorm norm;
   timeused timeMeter;
   
   C1rect2 set(x, norm);
   timeMap(M_2PI, set);
   
   scon << "\n\n \\Phi(x, 2pi) = " << (IntervalVector(set))  << "\n\n diam = " << size(IntervalVector(set))
        << "\nTime used : "<< timeMeter<< "\n";

   timeMeter.reset();

   C1rect2 set2(x, norm);
   timeMap2(M_2PI, set2); 
   
   scon << "\n\n Time Step control \n \\Phi(x, 2pi) = " << (IntervalVector(set2))  << "\n\n diam = " << size(IntervalVector(set2))      << "\n Time used : "<< timeMeter <<"\n";



   return 0;
}
